Name:           selenium-remote-control
Version:        1.0.3
Release:        5.20100318svn%{?dist}
Summary:        Tool for remotely controlling a web browser to test a web site

Group:          Development/Tools
# selenium: ASL 2.0
# parts of jetty: ASL 2.0
License:        ASL 2.0
URL:            http://seleniumhq.org/projects/core/
# svn export -r8153 http://selenium.googlecode.com/svn/selenium-rc/trunk@8153 selenium-remote-control
# tar czf selenium-remote-control.tar.gz selenium-remote-control
Source0:        selenium-remote-control.tar.gz
Source1:        selenium-server.script
Patch0:         server-coreless-1.0.1-tests.patch
Patch1:         selenium-remote-control-1.0.3-java.patch
Patch2:         selenium-remote-control-1.0.3-version.patch
# http://jira.openqa.org/browse/SRC-802
Patch10:        http://jira.openqa.org/secure/attachment/12212/selenium-safari-cleanup.patch
# http://jira.openqa.org/browse/SRC-831
Patch11:        http://jira.openqa.org/secure/attachment/12399/selenium-remote-control-1.0.3-chrome-quotes.patch

BuildRequires:  ant-trax
BuildRequires:  jakarta-commons-codec
BuildRequires:  junit4
BuildRequires:  maven2
BuildRequires:  tomcat5
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  bouncycastle
BuildRequires:  mx4j
BuildRequires:  selenium-core
BuildRequires:  ant
BuildRequires:  python
BuildRequires:  python-docutils
BuildArch:      noarch

%description
Selenium Remote Control (RC) is a test tool that allows you to write
automated web application UI tests in any programming language against any
HTTP website using any mainstream JavaScript-enabled browser.


%package -n selenium-server
Summary:        Remote browser control server
Group:          Development/Tools
Requires:       jpackage-utils
Requires:       selenium-core
Requires:       ant
Requires:       jakarta-commons-logging
Requires:       servlet
Requires:       bouncycastle
Provides:       selenium-server-coreless = %{version}-%{release}

%description -n selenium-server
A server which automatically launches and kills browsers, and acts as a HTTP
proxy for web requests from them.

Install perl-Test-WWW-Selenium, python-selenium or selenium-java-client-driver
for client libraries (for Perl, Python and Java respectively).


%package -n selenium-java-client-driver
Summary:        Client library for controlling browser from a Java program
Group:          Development/Libraries
Requires:       jpackage-utils

%description -n selenium-java-client-driver
A Java client library for remote control running via Selenium server.
Install selenium-server package for the server part.


%package -n python-selenium
Summary:        Client library for controlling browser from a Python script
Group:          Development/Libraries
Requires:       python

%description -n python-selenium
A Python client library for remote control running via Selenium server.
Install selenium-server package for the server part.


%prep
%setup -q -n %{name}
%patch0 -p0 -b .test
%patch1 -p1 -b .java
%patch2 -p1 -b .version
cd server-coreless
%patch10 -p1 -b .safari-cleanup
%patch11 -p1 -b .chrome-quotes


%build
find -name '*.jar' -delete

MAVEN_REPO_LOCAL=$PWD/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

find -type f -print0 |xargs -0 sed -i \
        's/@RCVERSION@/%{version}/g;s/@RCREVISION@/%{release}/g'

# TODO: poms/depmaps for these
# server-coreless
mvn-jpp install:install-file -DgroupId=mx4j -DartifactId=mx4j-tools \
        -Dversion=3.0.1 -Dpackaging=jar \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dfile=$(build-classpath mx4j/mx4j-tools)

mvn-jpp install:install-file -DgroupId=bouncycastle \
        -DartifactId=bcprov-jdk15 -Dversion=135 -Dpackaging=jar \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dfile=$(build-classpath bcprov)

# We don't run tests since we lack easymockclassextension
# (why do we need to patch the dependencies away when they're
# only needed in test scope?)

# Build the server part (w/o bundled core)
pushd server-coreless
mvn-jpp install \
	-Dproject.version=%{version} \
        -Dmaven.test.skip=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL
popd

# The jar we just built
# We should probably adjust the standalone to coreless dependency in POM
# Besides that, why do we even need it? The API definition is in core anyway
mvn-jpp install:install-file -DgroupId=org.seleniumhq.selenium.server \
        -DartifactId=selenium-server -Dversion=1.0.2-SNAPSHOT \
        -Dclassifier=standalone -Dpackaging=jar \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dfile=$(echo server-coreless/target/selenium-server-coreless-*.jar)

# Build the java bindings
# TODO: Other languages (perl is in separate package from CPAN,
# it would probably be wiser to build it here)
# Ruby bindings are maintained separately at http://github.com/ph7/selenium-client
pushd clients/java
mvn-jpp install \
        -Dmaven.test.skip=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL
popd

# Python client driver
pushd clients/python3
# Generate code
mkdir -p target
unzip -qc $(build-classpath selenium-core) core/iedoc.xml >target/iedoc.xml
ant generate-sources
# Generate documentation. Well...
mkdir -p doc
cat >doc/placeholder.txt <<EOF
Documentation build is pending fix of
https://bugzilla.redhat.com/show_bug.cgi?id=578920
EOF
# epydoc --simple-term selenium.py -o doc
popd


%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_javadir}
install -d $RPM_BUILD_ROOT%{_datadir}/maven2/poms

# Server
pushd server-coreless
install -p -m644 target/selenium-server-coreless-*.jar \
        $RPM_BUILD_ROOT%{_javadir}/selenium-server-coreless-%{version}.jar
ln -s selenium-server-coreless-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/selenium-server-coreless.jar
install -p -m644 pom.xml \
        $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP-selenium-server-coreless.pom
%add_to_maven_depmap org.apache.maven selenium-server-coreless %{version} JPP selenium-server-coreless
mv $RPM_BUILD_ROOT%{_mavendepmapfragdir}/%{name} \
        $RPM_BUILD_ROOT%{_mavendepmapfragdir}/selenium-server-coreless
popd

install -d $RPM_BUILD_ROOT%{_bindir}
install -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/selenium-server

# Java client driver
pushd clients/java
install -p -m644 target/selenium-java-client-driver-*.jar \
        $RPM_BUILD_ROOT%{_javadir}/selenium-java-client-driver-%{version}.jar
ln -s selenium-java-client-driver-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/selenium-java-client-driver.jar
install -p -m644 pom.xml \
        $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP-selenium-java-client-driver.pom
%add_to_maven_depmap org.apache.maven selenium-java-client-driver %{version} JPP selenium-java-client-driver
mv $RPM_BUILD_ROOT%{_mavendepmapfragdir}/%{name} \
        $RPM_BUILD_ROOT%{_mavendepmapfragdir}/selenium-java-client-driver
popd

# Python client driver
pushd clients/python3
install -d $RPM_BUILD_ROOT%{python_sitelib}
install -p -m644 selenium.py $RPM_BUILD_ROOT%{python_sitelib}
popd


%clean
rm -rf $RPM_BUILD_ROOT


%post -n selenium-server
%update_maven_depmap

%postun -n selenium-server
%update_maven_depmap


%post -n selenium-java-client-driver
%update_maven_depmap

%postun -n selenium-java-client-driver
%update_maven_depmap


%files -n selenium-server
%defattr(-,root,root,-)
%{_bindir}/selenium-server
%{_javadir}/selenium-server-coreless.jar
%{_javadir}/selenium-server-coreless-%{version}.jar
%{_mavendepmapfragdir}/selenium-server-coreless
%{_datadir}/maven2/poms/JPP-selenium-server-coreless.pom
%doc license/selenium_license.txt


%files -n selenium-java-client-driver
%defattr(-,root,root,-)
%{_javadir}/selenium-java-client-driver.jar
%{_javadir}/selenium-java-client-driver-%{version}.jar
%{_mavendepmapfragdir}/selenium-java-client-driver
%{_datadir}/maven2/poms/JPP-selenium-java-client-driver.pom
%doc license/selenium_license.txt


%files -n python-selenium
%defattr(-,root,root,-)
%{python_sitelib}/*
%doc clients/python3/doc/*
%doc license/selenium_license.txt


%changelog
* Tue Apr 20 2010 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.3-5.20100318svn
- Remove chrome argument quoting workaround
- Fill in version and revision (Jiri Kastner, #581756)

* Thu Apr 01 2010 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.3-4.20100318svn
- Selenium core provides Maven depmap now
- Build python client driver
- Add maven depmaps

* Tue Mar 30 2010 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.3-3.20100318svn
- Package Java bindings (#576037)

* Tue Mar 30 2010 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.3-2.20100318svn
- Add missing bouncycastle provider dependency

* Thu Mar 18 2010 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.3-1.20100318svn
- Update to later snapshot since upstream failed to tag release, support for Firefox 3.6

* Thu Feb 11 2010 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.2-0.4.20091211svn
- Move the requires to selenium-server subpackage

* Tue Jan 05 2010 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.2-0.3.20091211svn
- Fix Safari cleanup

* Fri Dec 11 2009 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.2-0.2.20091211svn
- Fux up dependencies
- Add launcher script

* Fri Dec 11 2009 Lubomir Rintel (GoodData) <lubo.rintel@gooddata.com> - 1.0.2-0.1.20091211svn
- Initial packaging
